#include "lib/lib.h"

int main()
{
	cout << "________________________\n";
	cout << "Dynamic-cast-test START.\n";
	
	
	const int countNumbersParent = 2;
	NumbersParent* numbers[countNumbersParent];
	
	numbers[0]  = new Number<int>();
	numbers[1]  = new Number<double>();
	
	cout << "\n";
	for (int i=0; i<countNumbersParent; i++) {
		Number<int> *pRealCat =  dynamic_cast<Number<int> *> (numbers[i]);
		
		if (pRealCat)
			cout << "-----> All Ok!\n";
		else if (i==0)
			cout << "-----> DONT work!\n";
		
		delete numbers[i];
	}
	cout << "\n";
	
	cout << "Dynamic-cast-test END.\n";
	cout << "----------------------\n";
	
	return 0;
}